;Programa controlador de la interrupcin 8 (TIMER) y pantalla
;Es para la pantalla VGA.

FRAMES_MAX                      equ 4
;Numero de frames perdidos para indicar que se ha perdido sincronismo

int8_ax dw ?
int8_bx dw ?
int8_cx dw ?
int8_dx dw ?
int8_bp dw ?
int8_si dw ?
int8_di dw ?
int8_ds dw ?

int8:

					mov   word ptr cs:[int8_ds],ds
					mov   word ptr cs:[int8_ax],ax
					mov   ax,cs
					mov   ds,ax

					test  bits_estado6,00001000b
					jz    int8_nocargando

					jmp   int8_cargando
int8_nocargando:


					;Hacer sonido del puerto 254 a traves altavoz (si conviene)
					;Mirar frecuencia
					dec	frecuencia_sonido_actual
					jnz   sincronizar_cpu_no_sonido

					;Mirar si esta en modo salida a Sblaster
					test	bits_estado3,00001000b
					jz 	sincronizar_cpu_no_sonido

					;Mirar si esta en modo interrupcion
					test  bits_estado6,00100000b
					jnz   sincronizar_cpu_no_sonido

					mov	al,frecuencia_sonido
					mov	frecuencia_sonido_actual,al
					mov   ah,previo_salida_sonido

					;Mirar si esta presente sound blaster
					cmp   soundblaster_presente,1
					jnz   sincronizar_cpu_no_sonido

					mov   int8_bx,bx
					mov   int8_cx,cx
					mov   int8_dx,dx
					mov   int8_bp,bp
					mov   int8_si,si
					mov   int8_di,di

					call  out211_blaster

					mov   bx,int8_bx
					mov   cx,int8_cx
					mov   dx,int8_dx
					mov   bp,int8_bp
					mov   si,int8_si
					mov   di,int8_di



sincronizar_cpu_no_sonido:



					mov   ax,sync_fin_linea
					inc   ax
					mov   sync_fin_linea,ax
					cmp   ax,311*FRAMES_MAX
					;311 o 312, es igual

					jc    int8_fin

					mov   sync_fin_linea,311*FRAMES_MAX ;Ha pasado demasido tiempo
					;sin llegar a los 224 (o 228) T estados. No incrementar mas
					or		bits_estado6,1
					jmp	short int8_fin_

int8_fin:
					and	bits_estado6,11111110b ;No hay perdida de sincronismo
int8_fin_:
					mov	ax,sync_lineas_actual_ula
					inc	ax
					cmp	ax,sync_lineas
					jnz	int8_fin2


					mov	sync_lineas_actual_ula,0
int8_cargando:
					call	int8_0
					jmp	short int8_fin3

int8_fin2:
					mov	sync_lineas_actual_ula,ax
int8_fin3:

					mov   ds,int8_ds
					mov	al,32
					out	32,al
					mov   ax,word ptr cs:[int8_ax]
					nop
					nop
					iret



int8_0:


					or		bits_estado4,01000000b ;Decir que ha habido int. 8

					;Incrementar reloj MS-DOS
					dec   reloj_msdos
					jnz   int8_2

					mov   reloj_msdos,250
					push  es
					mov   ax,40h
					mov   es,ax
					add   word ptr es:[6ch],91
					jnc   int8_1
					inc   word ptr es:[6eh]
int8_1:
					pop   es


int8_2:
					dec	contador_refresco_ay

					jnz	no_refresco

					mov	contador_refresco_ay,total_refresco_ay
					call	refrescar_chip_ay

no_refresco:

					dec	contador_flash
					jnz	no_cambio_flash
					xor	bits_estado,00100000b
					mov	contador_flash,25

					call	inc_seg_salvapan

no_cambio_flash:

					test  bits_estado2,01000000b
					jz		no_disparador ;No actua el disparador automtico  jz

					dec	byte ptr disparador
					jnz	no_disparador
					xor   byte ptr puerto_221,16
					mov	al,disparador_defecto
					mov	disparador,al

no_disparador:
					cmp   contador_disco,0 ;si est a 0, disco parado
					jz 	disco_parado ;jz
					dec	contador_disco
					jnz	disco_parado
					;Apagar motor de disco

					mov   int8_dx,dx
					mov	al,0ch
					mov	dx,3f2h
					out	dx,al
					mov   dx,int8_dx

disco_parado:

interrupciones_di:

					ret


contador_flash db		25
segundos			equ	3 ;3 segundos antes de parar motor de disco
contador_disco db		50*segundos ;Cuando se acabe de llamar a las funciones
reloj_msdos    db    250 ;Cuando llega a 0, se incrementa el reloj del MS-DOS
;en 91=18.2*5
											;se apague el motor

total_refresco_ay		equ	25
contador_refresco_ay	db	total_refresco_ay

