;Este fichero contiene las rutinas de control de la pantalla VGA

PUBLIC vga_poke_byte


vga_presente	db		? ;Contiene 1 si se encuentra tarjeta VGA,
							  ;si es 0=CGA/Hercules. Ya no se usa

seg_vga			dw		0a000h  ;es una constante


;Variables usadas en la actualizacion de pantalla mediante lineas

pantalla_origen dw	offset pantalla_tabla ;Offset a pantalla_tabla de la direccion
;de memoria de pantalla Spectrum que se va a leer

pantalla_destino dw	? ;Direccion de memoria de pantalla PC que se va a escribir

pantalla_tabla		db 192*2*2 dup (?)
;Tabla de correspondencia de cada linea de pantalla con
;su direccion en pixels y atributos del Spectrum. Cada entrada
;tiene la direccion en pixels y luego atributos.
;Ejemplo: 16384,22528,16640,22528, etc


_poke_byte_rom00:
					;Mirar si esta en modo Inves
					test	bits_estado5,00100000b
					jz    _poke_byte_rom0
					;Ver si se pokea una direccion del tipo XXFEH
					cmp   bl,0feh
					jnz   _poke_byte_rom0
					mov	valor_poke_rom,al ;Guardar valor del poke

_poke_byte_rom0:
					;Mirar si esta paginacion de RAM en ROM
					test	puerto_8189,1
					jnz 	vga_poke_byte000

_poke_byte_rom:
					ret

vga_poke_byte:	;Hace un poke de byte comprobando si se est en ROM
					;o en pantalla
					;Entrada: BX=Direccin
					;			 AL=Byte
					;Registros modificados:
					;AX,BX,CX,DX,BP,DI
COMMENT!
Esta rutina ha de ser la ms rpida de todo el emulador, por lo que se
eliminan las sentencias de bucles repetitivos.
!
					cmp	bh,64 ;Comprobar si se pokea en ROM
					jc		_poke_byte_rom00 ;Se hace as porque es ms probable
					;que no se pokee en ROM. Por lo tanto, al no pokear
					;en ROM es ms rpido

vga_poke_byte000:

					cmp	byte ptr es:[bx],al
					jz		_poke_byte_rom

vga_poke_byte00:

					poke128k
					;Devuelve C si debe actualizar la pantalla
					;NC si no debe

vga_poke_byte0:

					;
					ret
					;

actualiza_pantalla: ;Redibujar la pantalla. Comun a VGA y CGA

					push	es
					;Poner el buffer de multitarea a 0
					mov	es,seg_pantalla_multitarea
					xor	bx,bx
					mov	cx,3456 ;6912/2

actualiza_pantalla0_buc:

					mov	word ptr es:[bx],0
					inc	bx
					inc	bx
					loop  actualiza_pantalla0_buc

					pop	es

					;Guardar valores de pantalla_origen, pantalla_destino
					mov	ax,pantalla_origen
					push	ax
					mov	ax,pantalla_destino
					push	ax

					mov	pantalla_origen,offset pantalla_tabla
					mov	pantalla_destino,320*4

					mov	cx,192

actualiza_pantalla1:
					push	cx

					call	vga_actualiza_linea20

					pop	cx

					loop	actualiza_pantalla1

					pop	ax
					mov	pantalla_destino,ax

					pop	ax
					mov	pantalla_origen,ax

					ret


vga_inicializa_pantalla:

					;Poner modo VGA
					mov   ax,0013h    ;0013h ;320*200*256 colores
					int	10h
					ret

vga_apaga_pantalla:

COMMENT !

Informacion extraida de PCGPE


------------------------------------------------------------
Port-Index: -                Port: 03bah,03dah ; read only
usage:      d3  Vertical retrace
				d0  Horizontal retrace
!
					;Apagar pantalla
					mov	dx,03dah
apaga_pantalla0:
					in		al,dx
					test	al,00001000b
					jnz 	apaga_pantalla0
apaga_pantalla00:
					in		al,dx
					test	al,00001000b
					jz 	apaga_pantalla00
					mov	al,control_brillo
					or		al,al
					jns 	apaga_pantalla2
					cmp	al,-57
					jc		apaga_pantalla3
apaga_pantalla2:
					dec	al
					mov	control_brillo,al
					;Esperar una interrupcion 8 (y cada 50 Hz)
					and	bits_estado4,10111111b ;Eliminar int. pendiente

					call	vga_actualiza_brillo
apaga_pantalla2_esp:
					test	bits_estado4,01000000b
					jz		apaga_pantalla2_esp

					jmp	short vga_apaga_pantalla

apaga_pantalla3:
					ret




vga_copia_paleta:	;copia la paleta de brillo 0 y 1 a buffer_paleta
					mov		si,brillo0
					mov		di,offset buffer_paleta
					mov		cx,16*3
copia_paleta0:	lodsb
					mov		byte ptr [di],al
					inc		di
					loop		copia_paleta0
					ret

vga_inicializa_paleta:

					xor 		al,al
					mov		dx,3c8h
					out		dx,al
					inc		dx

					mov		cx,8
					mov		si,brillo0
					cld
ini_paleta1:	lodsb
					and		al,parametro_vgaR
					out		dx,al ;Red
					lodsb
					and		al,parametro_vgaG
					out		dx,al ;Green
					lodsb
					and		al,parametro_vgaB
					out		dx,al ;Blue
					loop		ini_paleta1

					mov		al,64
					mov		dx,3c8h
					out		dx,al
					inc		dx

					mov		cx,8
					mov		si,brillo1
ini_paleta2:	lodsb
					and		al,parametro_vgaR
					out		dx,al ;Red
					lodsb
					and		al,parametro_vgaG
					out		dx,al ;Green
					lodsb
					and		al,parametro_vgaB
					out		dx,al ;Blue
					loop		ini_paleta2

;Poner color de color_tinta y color_papel

					mov		al,9
					mov		dx,3c8h
					out		dx,al
					inc		dx

					mov		si,offset tinta_menu
					lodsb
					out		dx,al
					lodsb
					out		dx,al
					lodsb
					out		dx,al

					lodsb
					out		dx,al
					lodsb
					out		dx,al
					lodsb
					out		dx,al

					ret

vga_pon_color_borde0:
;Usado por load

					cli
					mov		al,8
					mov		dx,3c8h
					out		dx,al
					inc		dx
					mov		al,border
					mov		cl,3
					mul		cl
					xor		ah,ah
					mov		si,brillo0
					add		si,ax
					lodsb
					and		al,parametro_vgaR
					out		dx,al
					lodsb
					and		al,parametro_vgaG
					out		dx,al
					lodsb
					and		al,parametro_vgaB
					out		dx,al
					sti
					ret


vga_pon_marca_borde0:
;Usado por load

					push		es                 ;   -----------  <-
					mov		es,seg_vga         ;   --       --
					cld                         ;   --       --
					mov		ax,0808h           ;   -----------

					mov      di,320*4
					mov		bx,192             ;   -----------
pon_marca1:    mov		cx,32/2            ;   -- <- -> --
					rep		stosw              ;   --       --
					add      di,256             ;   --       --
					mov		cx,32/2 				 ;   -----------
					rep		stosw
					dec		bx
					jnz		pon_marca1
														 ;   -----------
					pop      es                 ;   --       --
					ret								 ;   --       --
														 ;   --       --
														 ;   -----------  <-

print_char_inicio:
;Rutina comun a la print char de CGA y VGA para que indiquen al buffer
;de multitarea que las 9 direcciones de pantalla de Spectrum de 1 caracter
;estan ocupadas.

					test		bits_estado4,10000000b
					jz			print_char_inicio_si
					ret

print_char_inicio_si:
					;Convertir linea,columna a formato direccin de pixels
					;de Spectrum (16384-22527):
					;     byte alto        byte bajo
					;bit  7 6 5 4 3 2 1 0  7 6 5 4 3 2 1 0
					;     0 1 0 L L S S S  L L L C C C C C

					mov		bl,cursor_y
					mov		bh,bl
					ror		bl,1
					ror		bl,1
					ror		bl,1
					and		bl,11100000b
					or			bl,cursor_x
					and		bh,00011000b
					push		es
					mov		es,seg_pantalla_multitarea
					mov		cx,8

print_char_inicio_bucle:

					mov		byte ptr es:[bx],1
					inc		bh
					loop     print_char_inicio_bucle

					mov		bl,cursor_y
					xor		bh,bh
					shl		bx,1
					shl		bx,1
					shl		bx,1
					shl		bx,1
					shl		bx,1
					or			bl,cursor_x
					add		bx,6144
					mov		byte ptr es:[bx],1

					pop		es
					ret

poke_pantalla_inicio:
;Rutina comun a la poke_byte_pantalla de CGA y VGA para que miren si
;pueden pokear o no (si parte del menu esta encima de ese byte)
;Devuelve Z si pueden escribir


					;Reservar BX,AL,ES
					push		es
					push     bx

					mov		es,seg_pantalla_multitarea
					sub		bx,16384
					cmp		byte ptr es:[bx],0

					pop		bx
					pop		es
					ret

vga_actualiza_linea_ds dw ? ;Registro DS
vga_actualiza_linea_dx dw ? ;Registro DX
vga_actualiza_linea_cx dw ? ;Registro CX
vga_actualiza_linea_ax dw ? ;Registro AX
vga_actualiza_linea_si dw ? ;Registro SI
vga_actualiza_linea_di dw ? ;Registro DI

vga_actualiza_linea:

;Rutina para dibujar una linea en pantalla. Guardar AX
;Entrada: BX=sync_lineas_actual_z80
					mov   bx,sync_lineas_actual_z80
					cmp	bx,sync_borde_sup
					jnc	vga_actualiza_linea1
					ret ;Esta en el borde superior
vga_actualiza_linea1:
					cmp	bx,sync_borde_inf
					jc		vga_actualiza_linea2
					;Esta en el borde inferior
					ret

vga_actualiza_linea2:
					mov   vga_actualiza_linea_ax,ax
					mov   vga_actualiza_linea_dx,dx
					mov   vga_actualiza_linea_si,si
					mov   vga_actualiza_linea_di,di


					test  bits_estado6,1 ;Ver si perdida de sincronismo
					jz    vga_actualiza_linea20

;					bits_estado6	 db	 0
COMMENT !
  Byte de estado n 6. Codificacin:
  bit
  ---
  7   No usado
  6   A 1 indica que la actualizacion de pantalla es baja; si no,alta
!

					test	bits_estado6,01000000b
					jnz   vga_actualiza_linea200
					mov	sync_fin_linea,0

vga_actualiza_linea200:

					add	pantalla_origen,4

					mov   di,pantalla_destino
					add   di,32+256

					jmp   vga_actualiza_linea31
vga_actualiza_linea20:
					;Dibujar borde izquierdo.

					mov	es,seg_vga         ;   --
					cld                      ;   --
					mov	di,pantalla_destino
					mov	al,border
					mov	ah,al
					mov	cx,32/2
					rep   stosw

					add   di,256
					mov   cx,32/2
					rep   stosw
					sub   di,256+32


					;Preparar contadores
					mov	cx,32 ;bytes pantalla Spectrum

					mov   bx,pantalla_origen
					mov	si,word ptr [bx]
					mov	bp,word ptr [bx+2]
					add	bx,4
					mov	pantalla_origen,bx

					mov   vga_actualiza_linea_ds,ds

vga_actualiza_linea_buc:

					test	bits_estado4,00100000b
					jz    vga_actualiza_linea_buc0

					;Como esta el menu, mirar si se puede POKEar
					mov   bx,si
					call	poke_pantalla_inicio
					jz    vga_actualiza_linea_buc0
					jmp   vga_actualiza_linea30
vga_actualiza_linea_buc0:

					mov   vga_actualiza_linea_cx,cx
					mov	es,seg_pant
					;Leer atributo
					mov	dh,byte ptr es:[bp]
					;En DH atributo

					mov	al,byte ptr es:[si]
					;En AL byte

					mov	es,seg_vga

					;Poner color en caso de que sea 0 o 1

					;En AL byte a pokear en zona pixels
					;En DH color
					test	dh,128 ;Comprobar si tiene flash
					jz	   vga_actualiza_linea_nof

					test	bits_estado,00100000b
					jnz	vga_actualiza_linea_nof

					 ;Ahora DH contendra el color en el caso de que el bit
					 ;de pixel este a 1 (papel)
					 ;Ahora DL contendr el color en el caso de que el bit
					 ;de pixel este a 0 (tinta)

					mov	dl,dh ;DH antes contenia el byte a pokear
					and	dl,01000111b
					mov	cl,dh
					and	cl,64 ;Conservar bit de brillo
					and	dh,00111000b
					ror	dh,1
					ror	dh,1
					ror	dh,1
					or		dh,cl
					jmp	short vga_actualiza_linea3

vga_actualiza_linea_nof:
					 ;Ahora DH contendra el color en el caso de que el bit
					 ;de pixel este a 1 (tinta)
					 ;Ahora DL contendr el color en el caso de que el bit
					 ;de pixel este a 0 (papel)
					mov	dl,dh ;DH antes contenia el color
					and	dh,01000111b
					mov	cl,dl
					and	cl,64 ;Conservar bit de brillo
					and	dl,00111000b
					ror	dl,1
					ror	dl,1
					ror	dl,1
					or		dl,cl

vga_actualiza_linea3:
					;Registros:
					;DH contendra el color en el caso de que el bit sea 1
					;DL contendra el color en el caso de que el bit sea 0
					;AL byte
					;DI pantalla_destino
					;ES seg_vga

					mov ds,seg_vga

					test	al,10000000b
					jz	   bit_7_cero
					mov   byte ptr [di],dh
					jmp	short bit_6
bit_7_cero:    mov   byte ptr [di],dl
bit_6: 			test	al,01000000b
					jz	   bit_6_cero
					mov   byte ptr [di+1],dh
					jmp	short bit_5
bit_6_cero:    mov   byte ptr [di+1],dl
bit_5: 			test	al,00100000b
					jz	   bit_5_cero
					mov   byte ptr [di+2],dh
					jmp	short bit_4
bit_5_cero:    mov   byte ptr [di+2],dl
bit_4: 			test	al,00010000b
					jz	   bit_4_cero
					mov   byte ptr [di+3],dh
					jmp	short bit_3
bit_4_cero:    mov   byte ptr [di+3],dl
bit_3: 			test	al,00001000b
					jz	   bit_3_cero
					mov   byte ptr [di+4],dh
					jmp	short bit_2
bit_3_cero:    mov   byte ptr [di+4],dl
bit_2: 			test	al,00000100b
					jz	   bit_2_cero
					mov   byte ptr [di+5],dh
					jmp	short bit_1
bit_2_cero:    mov   byte ptr [di+5],dl
bit_1: 			test	al,00000010b
					jz	   bit_1_cero
					mov   byte ptr [di+6],dh
					jmp	short bit_0
bit_1_cero:    mov   byte ptr [di+6],dl
bit_0: 			test	al,00000001b
					jz	   bit_0_cero
					mov   byte ptr [di+7],dh
					jmp	short bit_next
bit_0_cero:    mov   byte ptr [di+7],dl
bit_next:      mov   ds,word ptr cs:[vga_actualiza_linea_ds]

					mov   cx,vga_actualiza_linea_cx
vga_actualiza_linea30:
					add   di,8
					inc	si
					inc	bp
					dec	cx
					jz    vga_actualiza_linea31
					jmp   vga_actualiza_linea_buc

vga_actualiza_linea31:

					add   di,32


vga_actualiza_linea_fin:
					mov   pantalla_destino,di

					mov	es,seg_spectrum
					mov   di,vga_actualiza_linea_di
					mov   si,vga_actualiza_linea_si
					mov   dx,vga_actualiza_linea_dx
					mov   ax,vga_actualiza_linea_ax
					ret

crea_pantalla_tabla:
;Rutina que crea la tabla de la pantalla
					mov	bx,offset pantalla_tabla
					mov	cx,24 ;Lineas
					mov	ax,16384
					mov	dx,22528
crea_pantalla_tabla1:
					push	cx
					mov	cx,8 ;Scans

crea_pantalla_tabla2:
					mov 	word ptr [bx],ax
					mov	word ptr [bx+2],dx
					add	bx,4
					dec	cx
					jz		crea_pantalla_tabla3
					add	ax,256
					jmp	short crea_pantalla_tabla2
crea_pantalla_tabla3:
					;Cambio de linea
					add	dx,32
					;Formato de una direccin en la zona de pantalla
					;de pixels (16384-22527):
					;     byte alto        byte bajo
					;bit  7 6 5 4 3 2 1 0  7 6 5 4 3 2 1 0
					;     0 1 0 L L S S S  L L L C C C C C
					mov	cl,3
					rol	al,cl
					and   ax,1111100000000111b
					or		al,ah
					inc	al
					mov	ah,al
					ror	al,cl
					and	ax,1111100011100000b
					pop	cx
					loop  crea_pantalla_tabla1
					ret


